# RTLS Monitor

This application connects to a running `websocket_server` agent process connected to RTLS devices connected via serial port.

## Prerequisites

- CC2640R2SDK 3.10
  - [View in Resource Explorer](http://dev.ti.com/tirex/#/?link=Software%2FSimpleLink%20CC2640R2%20SDK)
  - [Download installer](http://www.ti.com/tool/download/SIMPLELINK-CC2640R2-SDK)
- LaunchPads programmed with example apps
  - rtls_master (one device)
  - rtls_slave (one device)
  - rtls_passive (one or more devices)
- Running RTLS Agent (`websocket_server`)
  - `<sdk folder>/tools/blestack/rtls_agent/rtls_agent_cli(.exe)`
  - **NOTE:** Agent tool should not connect to `rtls_slave` as it has no serial communication.

Please see `README.md` in the `tools/blestack/rtls_agent/` folder of the SDK for information on how to run the agent.

Run `rtls_agent_cli`, press 'a' to auto detect the devices. Then press enter to auto detect and connect to
`rtls_master` and `rtls_passive`.

## Using

If you launch `rtls_agent_cli` with no command line arguments, it will default to opening a websocket on port `8766`, which is the default configuration in the GUI.

Once the agent software is running, select if automatic RTLS should be enabled (checkbox next to reload button) and click `Connect`.
The behavior of automatic RTLS is described below.

## Automatic RTLS

If automatic RTLS is enabled, then the following steps will be performed automatically when clicking `Connect`.

 * Scan for RTLS slave devices
 * Connect to the first RTLS slave device that is detected
 * Pair and open L2CAP CoC
 * Enable AoA or ToF

If automatic RTLS is disabled, then the following must be done manually

 * Click the `Scan for Slave Devices` --> This will start a scan and put the Bluetooth address of found peers in the Remote devices list
 * Select the `rtls_slave` by clicking on the Bluetooth address in the remote devices list, then select `Connect to slave`
 * Select `Enable RTLS` to start AoA or ToF measurements.

Note that the buttons will only be enabled when they can be pressed.
For example `Connect to slave` is only enabled after `RTLS_CMD_SCAN_STOP` is received.

## Modifying

Import this GUI Composer project into GUI Composer via the gallery on dev.ti.com/gallery and change either the GUI or the code (app.js).